package com.yuandian.dataflow.proto.decode;

import java.nio.ByteBuffer;
import java.util.Date;

 

public class SstFlow extends PacketBase{

	public static int SIZE = 108;
	
	public long mac_src;  //源MAC
	public long mac_dst;  //目标MAC
	public long ip_src;   //源IP
	public long ip_dst;   //目标IP
	public int port_src; //源端口，如果没有，为-1
	public int port_dst; //目标端口，如果没有，为-1
	public int l3_proto; //第三层协议ID，如果没有，为-1
	public int l4_proto; //第四层协议ID，如果没有，为-1
	public int tos;      //Tos，一个字节，如果没有，为-1
	public int vlan_id;  //vlan ID，如果没有，为-1 
	
	public long bytes;    //字节总数
	public long packets;  //数据包总数
	 
	public long packets_syn;  //TCP同步包数
	public long packets_syn_ack; //TCP同步确认包数
	public long packets_syn_rst; //TCP同步重置包数

	public long timestamp; //时间戳,秒

	public long appid;//应用ID
	public long app_group_id;
	public int mpls_label;
	
	public long pkts_syn_rx; //tcp同步包，接收
	public long pkts_syn_ack_rx;//tcp同步确认包，接收
	public long pkts_syn_rst_rx; //tcp同步重置包，接收
	public long pkts_fin;//tcp终止包，接收
	public long pkts_rst;//tcp重置包，接收

	public long bytes_rx;//字节收
	public long packets_rx;//数据包收
	
	public long probe_time_sec;
	public Date probe_time;
	public Date createTime;
	
	public int probe_if;
	
	@Override
	public PacketBase  Parse(PacketHeader header,ByteBuffer data)
			throws Exception {
		SstFlow sstFlow = new SstFlow();
		sstFlow.mac_src = data.getLong(8);
		 
		sstFlow.mac_dst = data.getLong(8);
		 
		sstFlow.ip_src = data.getLong(8);
		 
		sstFlow.ip_dst = data.getLong(8);
		 
		sstFlow.port_src = data.getInt(4);
		 
		sstFlow.port_dst = data.getInt(4);
		 
		sstFlow.l3_proto = data.getInt(4);
		 
		sstFlow.l4_proto = data.getInt(4);
		 
		sstFlow.tos = data.getInt(4);
		 
		sstFlow.vlan_id = data.getInt(4);
		 

		sstFlow.bytes = data.getLong(8);
		 
		sstFlow.packets = data.getLong(8);
		 
		sstFlow.packets_syn = data.getLong(8);
		 
		sstFlow.packets_syn_ack = data.getLong(8);
		 
		sstFlow.packets_syn_rst = data.getLong(8);
		 
		sstFlow.appid = data.getInt(4);
		 
		sstFlow.app_group_id = data.getInt(4);
		 
		sstFlow.mpls_label = data.getInt(4);
		 
		sstFlow.timestamp = header.getTimestamp();
		sstFlow.probe_if = header.getProbeIf();
		return sstFlow;
	}

	@Override
	public int getUnitPacketLength() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public String[] getData() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getInterfaceNumber() {
		// TODO Auto-generated method stub
		return 0;
	}

}
